<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/Accessory.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('Accessory_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Accessory.hpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#ifndef __accessory_H__</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define __accessory_H__</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;DIO2.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef UNDEFINED_ID</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#define UNDEFINED_ID    ((unsigned long)-1)</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#ifndef UNDEFINED_POS</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define UNDEFINED_POS   (-32767)</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">enum</span> ACCESSORIES_MOVE_TYPE</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;{</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    ACCESSORIES_MOVE_MORE = +1,     </div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    ACCESSORIES_MOVE_LESS = -1,     </div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    ACCESSORIES_MOVE_STOP = 0,      </div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    ACCESSORIES_MOVE_LEFT = -2,     </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    ACCESSORIES_MOVE_RIGHT = -3,    </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    ACCESSORIES_MOVE_CENTER = -4,   </div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    ACCESSORIES_MOVE_TOP = -5,      </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    ACCESSORIES_MOVE_BOTTOM = -6,   </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    ACCESSORIES_MOVE_STRAIGHT = -7, </div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    ACCESSORIES_MOVE_DIVERGE = -8,  </div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    ACCESSORIES_MOVE_ON = -9,       </div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    ACCESSORIES_MOVE_OFF = -10      </div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;};</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">enum</span> ACCESSORIES_EVENT_TYPE</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;{</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    ACCESSORIES_EVENT_NONE = 0,             </div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    ACCESSORIES_EVENT_TOGGLE = 1,           </div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    ACCESSORIES_EVENT_MOVE = 2,             </div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    ACCESSORIES_EVENT_MOVEPOSITION = 3,     </div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    ACCESSORIES_EVENT_MOVEPOSITIONINDEX = 4,</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    ACCESSORIES_EVENT_MOVEPOSITIONID = 5,   </div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    ACCESSORIES_EVENT_CONFIG = 6,           </div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    ACCESSORIES_EVENT_DIRECTION = 20,       </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    ACCESSORIES_EVENT_SETSTARTPOSITION = 21,</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    ACCESSORIES_EVENT_SETSPEED = 22,        </div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    ACCESSORIES_EVENT_EXTERNALMOVE = 23,    </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;};</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">#define ACCESSORIESSCONFIG(address, value)  ( ((int)address&lt;&lt;8) | value )</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">#define ACCESSORIESCONFIGADDRESS(data)      highByte((int)data)</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#define ACCESSORIESCONFIGVALUE(data)        lowByte((int)data)</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="keyword">enum</span> ACC_STATE</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;{ </div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    STATE_NONE = 0,     </div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    STATE_FIRST = 1,    </div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    STATE_SECOND = 2    </div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;};</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="structMovingPosition.html">   74</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structMovingPosition.html">MovingPosition</a></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;{</div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="structMovingPosition.html#a2b52fcb92f3b4147f03fafe3c292029c">   76</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="structMovingPosition.html#a2b52fcb92f3b4147f03fafe3c292029c">Id</a>;   </div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="structMovingPosition.html#a0136a4ea90e9f0e61eebc441ed359e44">   77</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structMovingPosition.html#a0136a4ea90e9f0e61eebc441ed359e44">Position</a>;       </div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;};</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="classAccessory.html">  140</a></span>&#160;<span class="keyword">class </span><a class="code" href="classAccessory.html">Accessory</a></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;{</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    <span class="keyword">static</span> <a class="code" href="classAccessory.html">Accessory</a> *pFirstAccessory;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *pNextAccessory;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    </div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    uint8_t movingPositionsSize;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    uint8_t movingPositionsAddCounter;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <a class="code" href="structMovingPosition.html">MovingPosition</a> *pMovingPositions;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> duration;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> startingMillis;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    uint8_t lastMovingPosition;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> debounceDelay;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> lastMoveTime;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    ACC_STATE state;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> Add(<a class="code" href="classAccessory.html">Accessory</a> *inpAccessory);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keyword">static</span> <a class="code" href="classAccessory.html">Accessory</a> *GetById(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> CanMove(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#a9f524a5ba6ba7f33e814e687c2912181">Toggle</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId);</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> MovePosition(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId);</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">  167</a></span>&#160;    <a class="code" href="classPort.html">Port</a> *<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno"><a class="line" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">  170</a></span>&#160;    ACC_STATE <a class="code" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a>;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <a class="code" href="classAccessory.html#a64e6260a68ac84d94394a2076746f98a">Accessory</a>();</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno"><a class="line" href="classAccessory.html#af94464d9b49e5700d3c20d0cd206ac51">  180</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#af94464d9b49e5700d3c20d0cd206ac51">begin</a>(ACC_STATE inStartingState = STATE_NONE) { this-&gt;state = inStartingState; }</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno"><a class="line" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">  185</a></span>&#160;    <span class="keyword">inline</span> <a class="code" href="classPort.html">Port</a> *<a class="code" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>; }</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">ExecuteEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, <span class="keywordtype">int</span> inData = 0);</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <span class="keyword">static</span> uint8_t <a class="code" href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">GetCount</a>();</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#ae4efeb5b525027d5ccb692f0560a3474">IsActionPending</a>();</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> CheckPort() <span class="keyword">const</span>;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno"><a class="line" href="classAccessory.html#a6b837b3afb75f5eadcde5e1742db5c7d">  209</a></span>&#160;    <span class="keyword">inline</span> ACC_STATE <a class="code" href="classAccessory.html#a6b837b3afb75f5eadcde5e1742db5c7d">GetState</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;state; }</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;</div><div class="line"><a name="l00215"></a><span class="lineno"><a class="line" href="classAccessory.html#ae26158a4fc16855e72706b317c40f9e8">  215</a></span>&#160;    <span class="keyword">inline</span> ACC_STATE <a class="code" href="classAccessory.html#ae26158a4fc16855e72706b317c40f9e8">GetPreviousState</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">prevState</a>; }</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno"><a class="line" href="classAccessory.html#a69732e492455231abb564627cf66be7c">  220</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#a69732e492455231abb564627cf66be7c">IsNone</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;state == STATE_NONE; }</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00225"></a><span class="lineno"><a class="line" href="classAccessory.html#a05332408472b083ff1368172b79946be">  225</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#a05332408472b083ff1368172b79946be">IsFirst</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;state == STATE_FIRST; }</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div><div class="line"><a name="l00230"></a><span class="lineno"><a class="line" href="classAccessory.html#aecdd43db80db0467109219f68d5fb7e4">  230</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#aecdd43db80db0467109219f68d5fb7e4">IsSecond</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;state == STATE_SECOND; }</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    uint8_t <a class="code" href="classAccessory.html#a57d1cb4de69eb625fc2bb82788591a22">AddMovingPosition</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">int</span> inPosition);</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00243"></a><span class="lineno"><a class="line" href="classAccessory.html#ac818b7112183d3d65ec361c8402f927f">  243</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classAccessory.html#ac818b7112183d3d65ec361c8402f927f">GetDebounceDelay</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;debounceDelay; }</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div><div class="line"><a name="l00249"></a><span class="lineno"><a class="line" href="classAccessory.html#a933cd0907dc257b1f1047c33d41ceb2a">  249</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classAccessory.html#a933cd0907dc257b1f1047c33d41ceb2a">GetLastMoveTime</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;lastMoveTime; }</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;</div><div class="line"><a name="l00254"></a><span class="lineno"><a class="line" href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">  254</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">GetDuration</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;duration; }</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno"><a class="line" href="classAccessory.html#a5891e60944d8542a8bd1eb8862e5010e">  259</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#a5891e60944d8542a8bd1eb8862e5010e">loop</a>() { <span class="keywordflow">return</span> this-&gt;<a class="code" href="classAccessory.html#af693b11f2a3b1a7c93d7fa43e600f292">ActionEnded</a>(); }</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;</div><div class="line"><a name="l00266"></a><span class="lineno"><a class="line" href="classAccessory.html#a6f4a8cacc38e0bac6e83ed5a136073e0">  266</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a6f4a8cacc38e0bac6e83ed5a136073e0">Event</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, <span class="keywordtype">int</span> inData = 0) {}</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;<span class="keyword">public</span>: <span class="comment">//but should be protected !</span></div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classAccessory.html#a49f289549f486e8307ec06123939ca40">EEPROMSave</a>(<span class="keywordtype">int</span> inPos, <span class="keywordtype">bool</span> inSimulate = <span class="keyword">false</span>);</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">EEPROMLoad</a>(<span class="keywordtype">int</span> inPos);</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">AdjustMovingPositionsSize</a>(uint8_t inNewSize);</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00289"></a><span class="lineno"><a class="line" href="classAccessory.html#ac89f301db7c889f32aa8ab5534592975">  289</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#ac89f301db7c889f32aa8ab5534592975">IsEmpty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;pMovingPositions == NULL; }</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    uint8_t <a class="code" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">IndexOfMovingPosition</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId) <span class="keyword">const</span>;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">GetMovingPosition</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId) <span class="keyword">const</span>;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;</div><div class="line"><a name="l00307"></a><span class="lineno"><a class="line" href="classAccessory.html#a62eee418f630f805d36f6005e0db1a9e">  307</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">int</span> <a class="code" href="classAccessory.html#a62eee418f630f805d36f6005e0db1a9e">GetMovingPositionByIndex</a>(<span class="keywordtype">int</span> inIndex)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;pMovingPositions[inIndex].<a class="code" href="structMovingPosition.html#a0136a4ea90e9f0e61eebc441ed359e44">Position</a>; }</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;</div><div class="line"><a name="l00313"></a><span class="lineno"><a class="line" href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">  313</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">GetMovingPositionIdByIndex</a>(<span class="keywordtype">int</span> inIndex)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;pMovingPositions[inIndex].<a class="code" href="structMovingPosition.html#a2b52fcb92f3b4147f03fafe3c292029c">Id</a>; }</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;</div><div class="line"><a name="l00318"></a><span class="lineno"><a class="line" href="classAccessory.html#a292f4e066803d0f6f32a953216443c9d">  318</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">const</span> uint8_t <a class="code" href="classAccessory.html#a292f4e066803d0f6f32a953216443c9d">GetLastMovingPosition</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;lastMovingPosition; }</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div><div class="line"><a name="l00323"></a><span class="lineno"><a class="line" href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">  323</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">const</span> uint8_t <a class="code" href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">GetMovingPositionSize</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;movingPositionsSize; }</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">SetLastMovingPosition</a>(uint8_t inLastPositionIndex);</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00334"></a><span class="lineno"><a class="line" href="classAccessory.html#a83da11bad71b628431ac86cc1cbaf60c">  334</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a83da11bad71b628431ac86cc1cbaf60c">SetDebounceDelay</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> inDebounceDelay) { this-&gt;debounceDelay = inDebounceDelay; }</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno"><a class="line" href="classAccessory.html#af4a38203fce08f72755835ff126bddb0">  339</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#af4a38203fce08f72755835ff126bddb0">SetLastMoveTime</a>() { this-&gt;lastMoveTime = millis(); }</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;</div><div class="line"><a name="l00344"></a><span class="lineno"><a class="line" href="classAccessory.html#a6e68b4693371383dfb026869af30d1d2">  344</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a6e68b4693371383dfb026869af30d1d2">SetDuration</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inDuration) { this-&gt;duration = inDuration; }</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;</div><div class="line"><a name="l00350"></a><span class="lineno"><a class="line" href="classAccessory.html#a1d8deba14ebc355146c2ff26b4e4669c">  350</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a1d8deba14ebc355146c2ff26b4e4669c">SetNextAccessory</a>(<a class="code" href="classAccessory.html">Accessory</a> *inAccessory) { this-&gt;pNextAccessory = inAccessory; }</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;</div><div class="line"><a name="l00355"></a><span class="lineno"><a class="line" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">  355</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">static</span> <a class="code" href="classAccessory.html">Accessory</a> *<a class="code" href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">GetFirstAccessory</a>() { <span class="keywordflow">return</span> pFirstAccessory; }</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno"><a class="line" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">  360</a></span>&#160;    <span class="keyword">inline</span> <a class="code" href="classAccessory.html">Accessory</a> *<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;pNextAccessory; }</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;</div><div class="line"><a name="l00366"></a><span class="lineno"><a class="line" href="classAccessory.html#a8a9a9e26544b859289f125dd075cf52e">  366</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classAccessory.html#a8a9a9e26544b859289f125dd075cf52e">GetActionStartingMillis</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;startingMillis; }</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>();</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">StartAction</a>(ACC_STATE inState);</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a>();</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;</div><div class="line"><a name="l00385"></a><span class="lineno"><a class="line" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">  385</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">ResetAction</a>() { this-&gt;startingMillis = 0; }</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#af693b11f2a3b1a7c93d7fa43e600f292">ActionEnded</a>();</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;</div><div class="line"><a name="l00398"></a><span class="lineno"><a class="line" href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">  398</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">IsActionDelayPending</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;startingMillis &gt; 0; }</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;</div><div class="line"><a name="l00404"></a><span class="lineno"><a class="line" href="classAccessory.html#aef81e617d15f62090ccce7eee4f0d3c3">  404</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#aef81e617d15f62090ccce7eee4f0d3c3">IsGroupActionPending</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">IsActionDelayPending</a>(); }</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a2ab6995aadf87dd3f7edf1d2f448ab85">Move</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inMovingPositionId) = 0;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    <span class="keyword">virtual</span> ACC_STATE <a class="code" href="classAccessory.html#a9f524a5ba6ba7f33e814e687c2912181">Toggle</a>() = 0;</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;</div><div class="line"><a name="l00419"></a><span class="lineno"><a class="line" href="classAccessory.html#a212359e11100e5ee9af5bd94a64d8823">  419</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#a212359e11100e5ee9af5bd94a64d8823">CanBePositional</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;</div><div class="line"><a name="l00425"></a><span class="lineno"><a class="line" href="classAccessory.html#a3662f43014a6ec1f8719a687fe5c33ba">  425</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a3662f43014a6ec1f8719a687fe5c33ba">MovePosition</a>(<span class="keywordtype">int</span> inPosition) {}</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;</div><div class="line"><a name="l00430"></a><span class="lineno"><a class="line" href="classAccessory.html#a408602468720dbf84c1e3d27cc0385da">  430</a></span>&#160;    <span class="keyword">inline</span> <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a408602468720dbf84c1e3d27cc0385da">SetState</a>(ACC_STATE inNewState) { this-&gt;<a class="code" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">SetStateRaw</a>(inNewState); }</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">SetStateRaw</a>(ACC_STATE inNewState);</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;</div><div class="line"><a name="l00441"></a><span class="lineno"><a class="line" href="classAccessory.html#ac5208f338b6ea9a5b5fd554c4e1ec60e">  441</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#ac5208f338b6ea9a5b5fd554c4e1ec60e">SetStartingMillis</a>() { this-&gt;startingMillis = millis(); }</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;</div><div class="line"><a name="l00446"></a><span class="lineno"><a class="line" href="classAccessory.html#a882c7616f0433475d65e1ac5e8ecf616">  446</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a882c7616f0433475d65e1ac5e8ecf616">ResetStartingMillis</a>() { this-&gt;startingMillis = 0; }</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> printAccessory() {</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;        <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a>() != NULL)</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;            this-&gt;<a class="code" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a>()-&gt;printPort();</div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        this-&gt;printMovingPositions();</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;    }</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;    <span class="keywordtype">void</span> Accessory::printMovingPositions();</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;};</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="ttc" id="classAccessory_html_ac5208f338b6ea9a5b5fd554c4e1ec60e"><div class="ttname"><a href="classAccessory.html#ac5208f338b6ea9a5b5fd554c4e1ec60e">Accessory::SetStartingMillis</a></div><div class="ttdeci">void SetStartingMillis()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00441">Accessory.hpp:441</a></div></div>
<div class="ttc" id="classAccessory_html_a408602468720dbf84c1e3d27cc0385da"><div class="ttname"><a href="classAccessory.html#a408602468720dbf84c1e3d27cc0385da">Accessory::SetState</a></div><div class="ttdeci">virtual void SetState(ACC_STATE inNewState)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00430">Accessory.hpp:430</a></div></div>
<div class="ttc" id="classAccessory_html_a3662f43014a6ec1f8719a687fe5c33ba"><div class="ttname"><a href="classAccessory.html#a3662f43014a6ec1f8719a687fe5c33ba">Accessory::MovePosition</a></div><div class="ttdeci">virtual void MovePosition(int inPosition)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00425">Accessory.hpp:425</a></div></div>
<div class="ttc" id="classAccessory_html_a2ab6995aadf87dd3f7edf1d2f448ab85"><div class="ttname"><a href="classAccessory.html#a2ab6995aadf87dd3f7edf1d2f448ab85">Accessory::Move</a></div><div class="ttdeci">virtual void Move(unsigned long inMovingPositionId) = 0</div></div>
<div class="ttc" id="classAccessory_html_aef81e617d15f62090ccce7eee4f0d3c3"><div class="ttname"><a href="classAccessory.html#aef81e617d15f62090ccce7eee4f0d3c3">Accessory::IsGroupActionPending</a></div><div class="ttdeci">virtual bool IsGroupActionPending() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00404">Accessory.hpp:404</a></div></div>
<div class="ttc" id="structMovingPosition_html_a2b52fcb92f3b4147f03fafe3c292029c"><div class="ttname"><a href="structMovingPosition.html#a2b52fcb92f3b4147f03fafe3c292029c">MovingPosition::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00076">Accessory.hpp:76</a></div></div>
<div class="ttc" id="classAccessory_html"><div class="ttname"><a href="classAccessory.html">Accessory</a></div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00140">Accessory.hpp:140</a></div></div>
<div class="ttc" id="classAccessory_html_ac818b7112183d3d65ec361c8402f927f"><div class="ttname"><a href="classAccessory.html#ac818b7112183d3d65ec361c8402f927f">Accessory::GetDebounceDelay</a></div><div class="ttdeci">unsigned int GetDebounceDelay() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00243">Accessory.hpp:243</a></div></div>
<div class="ttc" id="classAccessory_html_a9f524a5ba6ba7f33e814e687c2912181"><div class="ttname"><a href="classAccessory.html#a9f524a5ba6ba7f33e814e687c2912181">Accessory::Toggle</a></div><div class="ttdeci">virtual ACC_STATE Toggle() = 0</div></div>
<div class="ttc" id="classPort_html"><div class="ttname"><a href="classPort.html">Port</a></div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00061">Port.hpp:61</a></div></div>
<div class="ttc" id="classAccessory_html_a212359e11100e5ee9af5bd94a64d8823"><div class="ttname"><a href="classAccessory.html#a212359e11100e5ee9af5bd94a64d8823">Accessory::CanBePositional</a></div><div class="ttdeci">virtual bool CanBePositional() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00419">Accessory.hpp:419</a></div></div>
<div class="ttc" id="classAccessory_html_ae8c3ad3e37a2ba5914f419abd3e2426f"><div class="ttname"><a href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">Accessory::IsActionDelayPending</a></div><div class="ttdeci">bool IsActionDelayPending() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00398">Accessory.hpp:398</a></div></div>
<div class="ttc" id="classAccessory_html_a64e6260a68ac84d94394a2076746f98a"><div class="ttname"><a href="classAccessory.html#a64e6260a68ac84d94394a2076746f98a">Accessory::Accessory</a></div><div class="ttdeci">Accessory()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00015">Accessory.cpp:15</a></div></div>
<div class="ttc" id="classAccessory_html_ac2883977d969dcde8f078934b4a9ed12"><div class="ttname"><a href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">Accessory::GetPort</a></div><div class="ttdeci">Port * GetPort() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00185">Accessory.hpp:185</a></div></div>
<div class="ttc" id="classAccessory_html_aa249535a3c36291764e38ab1e4ae4cee"><div class="ttname"><a href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">Accessory::GetMovingPosition</a></div><div class="ttdeci">int GetMovingPosition(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00068">Accessory.cpp:68</a></div></div>
<div class="ttc" id="structMovingPosition_html_a0136a4ea90e9f0e61eebc441ed359e44"><div class="ttname"><a href="structMovingPosition.html#a0136a4ea90e9f0e61eebc441ed359e44">MovingPosition::Position</a></div><div class="ttdeci">int Position</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00077">Accessory.hpp:77</a></div></div>
<div class="ttc" id="classAccessory_html_a6b837b3afb75f5eadcde5e1742db5c7d"><div class="ttname"><a href="classAccessory.html#a6b837b3afb75f5eadcde5e1742db5c7d">Accessory::GetState</a></div><div class="ttdeci">ACC_STATE GetState() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00209">Accessory.hpp:209</a></div></div>
<div class="ttc" id="classAccessory_html_a6cf36c65d1519eb7e5a6aac1cba7fe51"><div class="ttname"><a href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">Accessory::ExecuteEvent</a></div><div class="ttdeci">static void ExecuteEvent(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00388">Accessory.cpp:388</a></div></div>
<div class="ttc" id="classAccessory_html_a83da11bad71b628431ac86cc1cbaf60c"><div class="ttname"><a href="classAccessory.html#a83da11bad71b628431ac86cc1cbaf60c">Accessory::SetDebounceDelay</a></div><div class="ttdeci">void SetDebounceDelay(unsigned int inDebounceDelay)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00334">Accessory.hpp:334</a></div></div>
<div class="ttc" id="classAccessory_html_af4a38203fce08f72755835ff126bddb0"><div class="ttname"><a href="classAccessory.html#af4a38203fce08f72755835ff126bddb0">Accessory::SetLastMoveTime</a></div><div class="ttdeci">void SetLastMoveTime()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00339">Accessory.hpp:339</a></div></div>
<div class="ttc" id="classAccessory_html_af8b0920b2a419e278fbc79e3fcc75f86"><div class="ttname"><a href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">Accessory::GetCount</a></div><div class="ttdeci">static uint8_t GetCount()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00233">Accessory.cpp:233</a></div></div>
<div class="ttc" id="classAccessory_html_a3de65543a892b3418df72f54439605cb"><div class="ttname"><a href="classAccessory.html#a3de65543a892b3418df72f54439605cb">Accessory::ResetAction</a></div><div class="ttdeci">virtual void ResetAction()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00385">Accessory.hpp:385</a></div></div>
<div class="ttc" id="classAccessory_html_ae1ebffdf3fe753e3c5e7d05c2a61fd18"><div class="ttname"><a href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">Accessory::pPort</a></div><div class="ttdeci">Port * pPort</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00167">Accessory.hpp:167</a></div></div>
<div class="ttc" id="classAccessory_html_a7079494cf9cb5130e5b3a5762e04e947"><div class="ttname"><a href="classAccessory.html#a7079494cf9cb5130e5b3a5762e04e947">Accessory::prevState</a></div><div class="ttdeci">ACC_STATE prevState</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00170">Accessory.hpp:170</a></div></div>
<div class="ttc" id="classAccessory_html_ae26158a4fc16855e72706b317c40f9e8"><div class="ttname"><a href="classAccessory.html#ae26158a4fc16855e72706b317c40f9e8">Accessory::GetPreviousState</a></div><div class="ttdeci">ACC_STATE GetPreviousState() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00215">Accessory.hpp:215</a></div></div>
<div class="ttc" id="classAccessory_html_a5e837b6c4251c2fe69066d3146dd8478"><div class="ttname"><a href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">Accessory::SetLastMovingPosition</a></div><div class="ttdeci">void SetLastMovingPosition(uint8_t inLastPositionIndex)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00157">Accessory.cpp:157</a></div></div>
<div class="ttc" id="classAccessory_html_ab1dad31ee3bcac4b1baf9a140c7fa57d"><div class="ttname"><a href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">Accessory::StartAction</a></div><div class="ttdeci">virtual void StartAction()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00077">Accessory.cpp:77</a></div></div>
<div class="ttc" id="classAccessory_html_a933cd0907dc257b1f1047c33d41ceb2a"><div class="ttname"><a href="classAccessory.html#a933cd0907dc257b1f1047c33d41ceb2a">Accessory::GetLastMoveTime</a></div><div class="ttdeci">unsigned long GetLastMoveTime() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00249">Accessory.hpp:249</a></div></div>
<div class="ttc" id="classAccessory_html_af94464d9b49e5700d3c20d0cd206ac51"><div class="ttname"><a href="classAccessory.html#af94464d9b49e5700d3c20d0cd206ac51">Accessory::begin</a></div><div class="ttdeci">void begin(ACC_STATE inStartingState = STATE_NONE)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00180">Accessory.hpp:180</a></div></div>
<div class="ttc" id="classAccessory_html_a245ad3bad4fa0f1d657fdc20b2edb868"><div class="ttname"><a href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">Accessory::EEPROMLoad</a></div><div class="ttdeci">virtual int EEPROMLoad(int inPos)</div></div>
<div class="ttc" id="classAccessory_html_a05332408472b083ff1368172b79946be"><div class="ttname"><a href="classAccessory.html#a05332408472b083ff1368172b79946be">Accessory::IsFirst</a></div><div class="ttdeci">bool IsFirst() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00225">Accessory.hpp:225</a></div></div>
<div class="ttc" id="classAccessory_html_aecdd43db80db0467109219f68d5fb7e4"><div class="ttname"><a href="classAccessory.html#aecdd43db80db0467109219f68d5fb7e4">Accessory::IsSecond</a></div><div class="ttdeci">bool IsSecond() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00230">Accessory.hpp:230</a></div></div>
<div class="ttc" id="classAccessory_html_a8cfe1c1ca32753832146656755f6e7a7"><div class="ttname"><a href="classAccessory.html#a8cfe1c1ca32753832146656755f6e7a7">Accessory::GetDuration</a></div><div class="ttdeci">unsigned long GetDuration() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00254">Accessory.hpp:254</a></div></div>
<div class="ttc" id="classAccessory_html_a57d1cb4de69eb625fc2bb82788591a22"><div class="ttname"><a href="classAccessory.html#a57d1cb4de69eb625fc2bb82788591a22">Accessory::AddMovingPosition</a></div><div class="ttdeci">uint8_t AddMovingPosition(unsigned long inId, int inPosition)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00049">Accessory.cpp:49</a></div></div>
<div class="ttc" id="classAccessory_html_ac89f301db7c889f32aa8ab5534592975"><div class="ttname"><a href="classAccessory.html#ac89f301db7c889f32aa8ab5534592975">Accessory::IsEmpty</a></div><div class="ttdeci">bool IsEmpty() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00289">Accessory.hpp:289</a></div></div>
<div class="ttc" id="classAccessory_html_a5891e60944d8542a8bd1eb8862e5010e"><div class="ttname"><a href="classAccessory.html#a5891e60944d8542a8bd1eb8862e5010e">Accessory::loop</a></div><div class="ttdeci">bool loop()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00259">Accessory.hpp:259</a></div></div>
<div class="ttc" id="classAccessory_html_a6f4a8cacc38e0bac6e83ed5a136073e0"><div class="ttname"><a href="classAccessory.html#a6f4a8cacc38e0bac6e83ed5a136073e0">Accessory::Event</a></div><div class="ttdeci">virtual void Event(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00266">Accessory.hpp:266</a></div></div>
<div class="ttc" id="classAccessory_html_a49f289549f486e8307ec06123939ca40"><div class="ttname"><a href="classAccessory.html#a49f289549f486e8307ec06123939ca40">Accessory::EEPROMSave</a></div><div class="ttdeci">virtual int EEPROMSave(int inPos, bool inSimulate = false)</div></div>
<div class="ttc" id="classAccessory_html_acd67b5953eb1b55a52a87a779574e3b6"><div class="ttname"><a href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">Accessory::AdjustMovingPositionsSize</a></div><div class="ttdeci">void AdjustMovingPositionsSize(uint8_t inNewSize)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00029">Accessory.cpp:29</a></div></div>
<div class="ttc" id="structMovingPosition_html"><div class="ttname"><a href="structMovingPosition.html">MovingPosition</a></div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00074">Accessory.hpp:74</a></div></div>
<div class="ttc" id="classAccessory_html_a224977dffaa54df56def6a7b15af0031"><div class="ttname"><a href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">Accessory::IndexOfMovingPosition</a></div><div class="ttdeci">uint8_t IndexOfMovingPosition(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00059">Accessory.cpp:59</a></div></div>
<div class="ttc" id="classAccessory_html_ae4efeb5b525027d5ccb692f0560a3474"><div class="ttname"><a href="classAccessory.html#ae4efeb5b525027d5ccb692f0560a3474">Accessory::IsActionPending</a></div><div class="ttdeci">static bool IsActionPending()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00260">Accessory.cpp:260</a></div></div>
<div class="ttc" id="classAccessory_html_a62eee418f630f805d36f6005e0db1a9e"><div class="ttname"><a href="classAccessory.html#a62eee418f630f805d36f6005e0db1a9e">Accessory::GetMovingPositionByIndex</a></div><div class="ttdeci">int GetMovingPositionByIndex(int inIndex) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00307">Accessory.hpp:307</a></div></div>
<div class="ttc" id="classAccessory_html_a60e5e9122c96773c975fe9d2c2db6520"><div class="ttname"><a href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">Accessory::SetStateRaw</a></div><div class="ttdeci">void SetStateRaw(ACC_STATE inNewState)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00165">Accessory.cpp:165</a></div></div>
<div class="ttc" id="classAccessory_html_a4f0410f39fa692494b51bc880714bdd1"><div class="ttname"><a href="classAccessory.html#a4f0410f39fa692494b51bc880714bdd1">Accessory::GetMovingPositionIdByIndex</a></div><div class="ttdeci">unsigned long GetMovingPositionIdByIndex(int inIndex) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00313">Accessory.hpp:313</a></div></div>
<div class="ttc" id="classAccessory_html_a292f4e066803d0f6f32a953216443c9d"><div class="ttname"><a href="classAccessory.html#a292f4e066803d0f6f32a953216443c9d">Accessory::GetLastMovingPosition</a></div><div class="ttdeci">const uint8_t GetLastMovingPosition() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00318">Accessory.hpp:318</a></div></div>
<div class="ttc" id="classAccessory_html_a69732e492455231abb564627cf66be7c"><div class="ttname"><a href="classAccessory.html#a69732e492455231abb564627cf66be7c">Accessory::IsNone</a></div><div class="ttdeci">bool IsNone() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00220">Accessory.hpp:220</a></div></div>
<div class="ttc" id="classAccessory_html_ac4dc998e8f09ac7f94a3e06c56e8d5d4"><div class="ttname"><a href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">Accessory::GetMovingPositionSize</a></div><div class="ttdeci">const uint8_t GetMovingPositionSize() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00323">Accessory.hpp:323</a></div></div>
<div class="ttc" id="classAccessory_html_af693b11f2a3b1a7c93d7fa43e600f292"><div class="ttname"><a href="classAccessory.html#af693b11f2a3b1a7c93d7fa43e600f292">Accessory::ActionEnded</a></div><div class="ttdeci">virtual bool ActionEnded()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00134">Accessory.cpp:134</a></div></div>
<div class="ttc" id="classAccessory_html_a6e68b4693371383dfb026869af30d1d2"><div class="ttname"><a href="classAccessory.html#a6e68b4693371383dfb026869af30d1d2">Accessory::SetDuration</a></div><div class="ttdeci">void SetDuration(unsigned long inDuration)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00344">Accessory.hpp:344</a></div></div>
<div class="ttc" id="classAccessory_html_a882c7616f0433475d65e1ac5e8ecf616"><div class="ttname"><a href="classAccessory.html#a882c7616f0433475d65e1ac5e8ecf616">Accessory::ResetStartingMillis</a></div><div class="ttdeci">void ResetStartingMillis()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00446">Accessory.hpp:446</a></div></div>
<div class="ttc" id="classAccessory_html_a1d8deba14ebc355146c2ff26b4e4669c"><div class="ttname"><a href="classAccessory.html#a1d8deba14ebc355146c2ff26b4e4669c">Accessory::SetNextAccessory</a></div><div class="ttdeci">void SetNextAccessory(Accessory *inAccessory)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00350">Accessory.hpp:350</a></div></div>
<div class="ttc" id="classAccessory_html_ab89d2b99293b24e6ccc38938384563f2"><div class="ttname"><a href="classAccessory.html#ab89d2b99293b24e6ccc38938384563f2">Accessory::GetFirstAccessory</a></div><div class="ttdeci">static Accessory * GetFirstAccessory()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00355">Accessory.hpp:355</a></div></div>
<div class="ttc" id="classAccessory_html_aa27a04b9e2a95729e491598cb34c6e47"><div class="ttname"><a href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">Accessory::GetNextAccessory</a></div><div class="ttdeci">Accessory * GetNextAccessory() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00360">Accessory.hpp:360</a></div></div>
<div class="ttc" id="classAccessory_html_a8a9a9e26544b859289f125dd075cf52e"><div class="ttname"><a href="classAccessory.html#a8a9a9e26544b859289f125dd075cf52e">Accessory::GetActionStartingMillis</a></div><div class="ttdeci">unsigned long GetActionStartingMillis() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00366">Accessory.hpp:366</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>Accessory.hpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
